//MULTI
//multiplekser
MAX_SPRITES	equ 8		
POSY_MIN		equ 16
POSY_MAX		equ 208
	
POSX_MIN		equ 64
POSX_MAX		equ 184


sprite_x			org *+MAX_SPRITES		;pozycja X obiektu
sprite_dx			org *+MAX_SPRITES		;pozycja X po przecinku
sprite_y			org *+MAX_SPRITES
sprite_dy			org *+MAX_SPRITES	
sprite_shape		org *+MAX_SPRITES		;ksztalt obiektu
sprite_c0			org *+MAX_SPRITES		;kolor 0 obiektu
sprite_c1			org *+MAX_SPRITES		;kolor 1 obiektu
sprite_anim			org *+MAX_SPRITES		;liczba klatek animacji obiektu
sprite_anim_speed 	org *+MAX_SPRITES		;szybkość animacji obiektu


blok_status		org *+32	;tablica pomocnicza do ustalenia zajętości duszków
blok_x01		org *+32	;pozycje pary duszków 0 i 1
blok_x23		org *+32	;pozycje pary duszków 2 i 3
blok_c0			org *+32	;kolor duszka 0
blok_c1			org *+32
blok_c2			org *+32
blok_c3			org *+32	


.local multi
spr_flag	equ multi_zeropage
nr_duszka	equ multi_zeropage+1
poz_y		equ multi_zeropage+2
duch_dy		equ multi_zeropage+3


animuj
		lda zegar
		sta _em2+1

		ldx #MAX_SPRITES-1
@		lda sprite_x,x
		bne @+
next	dex
		bpl @-
		rts
@		
_em2	lda #$ff
		and sprite_anim_speed,x
		bne next
		lda sprite_anim,x
		beq next
		eor #255
		sta _em1-1
		eor #255

		and sprite_shape,x
		sta _em1+1
		inc sprite_shape,x		;animacja przeciwnikow	
		lda sprite_shape,x
		and #$ff				;odwrotnosc maski
_em1	ora #$ff
		sta sprite_shape,x  		
		jmp next
		
//inicjalizacja spritów
init_sprite	
		mva #MAX_SPRITES-1 start
		
init_sprite2
		lda #0
		tax
@		sta sprites+$300,x			;wyczysc duszki
		sta sprites+$400,x
		sta sprites+$500,x
		sta sprites+$600,x
		sta sprites+$700,x
		dex
		bne @-	
			
		rts



//narysuj wszystkie duszki
show_sprites	
		ldy #0		
		sty spr_flag 
		lda sprite_x
		beq *+5	
		jsr print_sprite			;gracz
		ldy start
		
@		lda sprite_x,y
		beq @+	
		jsr print_sprite
@		dey
		bne *+4
		ldy #MAX_SPRITES-1
start	equ *+1		
		cpy #MAX_SPRITES-1
		bne @-1
		
		
		lda spr_flag
		beq @+
		sta start
		
@		lda blok_x01+1			;player 0 i 1
		sta hposp1
		sta hposp0
		lda blok_c0+1
		sta colpm0
		lda blok_c1+1
		sta colpm1
		lda blok_x23+1			;player 2 i 3
		sta hposp3
		sta hposp2
		lda blok_c2+1
		sta colpm2
		lda blok_c3+1
		sta colpm3	

		lda #0	
		sta blok_x01+1
		sta blok_x23+1
		sta blok_status+1
		sta blok_status+28
		rts


//narysuj sprite nr w Y
print_sprite
		lda sprite_y,y		;juz odczytane
		sta poz_y
		:3 lsr
		tax				;nr pierwszego bloku
		lda poz_y
		and #%111
		sta duch_dy

		bne *+3
		dex				;jesli dy=0 to zmniejsz nr pierwszego bloku

		lda blok_status,x
		ora blok_status+1,x
		ora blok_status+2,x
		lsr
		bcc @+
		lsr
		jcc @+1
		
		lda spr_flag
		bne *+4
		sty spr_flag
		rts			;nie można narysować duszka
		
		
@		inc blok_status,x
		inc blok_status+2,x
		
//ustawienie pozycji i koloru duszków w bloku	
		lda blok_x01+3,x	
		bne *+5
		inc blok_x01+3,x
				
		lda sprite_x,y		;sprite 0 i 1
		sta blok_x01,x

		lda sprite_c0,y
		sta blok_c0,x
		lda sprite_c1,y
		sta blok_c1,x
			
		
		lda sprite_shape,y		
		tax
		

psp1b	lda shape_tab01,x
		sta _psp1+1
		lda shape_tab01+128,x
		sta _psp1+2
		
		sty nr_duszka
		ldx poz_y
_psp1	equ *		
		jsr $ffff
		ldy nr_duszka

		ldy duch_dy
		lda tab_skok01,y
		ldy nr_duszka
		
		sta l01
		lda #0
l01	equ *+1		
		jmp dy0 
		

@		lda #2
		ora blok_status,x			;zajmij wybranego duszka w statusie
		sta blok_status,x
		lda #2
		ora blok_status+2,x		
		sta blok_status+2,x


		lda blok_x23+3,x
		bne *+5
		inc blok_x23+3,x
						
		lda sprite_x,y			;sprite 2 i 3
		sta blok_x23,x

		lda sprite_c0,y
		sta blok_c2,x
		lda sprite_c1,y
		sta blok_c3,x	
	
		lda sprite_shape,y
		tax
		
psp2b	lda shape_tab23,x
		sta _psp2+1
		lda shape_tab23+128,x
		sta _psp2+2
			
		sty nr_duszka
		ldx poz_y
_psp2	equ *		
		jsr $ffff
		ldy nr_duszka	 
		
		ldy duch_dy
		lda tab_skok23,y
		ldy nr_duszka
		
		sta l23
		lda #0
l23	equ *+1		
		jmp dy0b


		.align	

//tablice kształtów		max=128
//duszki 0 i 1
shape_tab01
		dta <moneta0a,<moneta1a,<moneta2a,<moneta3a,<moneta4a,<moneta5a,<moneta6a,<moneta7a		;0=moneta
_ad0	equ *		
		:128-(_ad0-shape_tab01) dta 0
		
		dta >moneta0a,>moneta1a,>moneta2a,>moneta3a,>moneta4a,>moneta5a,>moneta6a,>moneta7a
_ad1	equ *		
		:256-(_ad1-shape_tab01) dta 0		
//duszki 2 i 3
shape_tab23
		dta <moneta0b,<moneta1b,<moneta2b,<moneta3b,<moneta4b,<moneta5b,<moneta6b,<moneta7b
_ad2	equ *		
		:128-(_ad2-shape_tab23) dta 0		

		dta >moneta0b,>moneta1b,>moneta2b,>moneta3b,>moneta4b,>moneta5b,>moneta6b,>moneta7b
_ad3	equ *		
		:256-(_ad3-shape_tab23) dta 0			
		
tab_skok01	dta <dy0,<dy1,<dy2,<dy3,<dy4,<dy5,<dy6,<dy7		

		
dy0		
		sta sprites+$400+$10,x
		sta sprites+$500+$10,x
			
		sta sprites+$400-8,x
		sta sprites+$400-7,x
		sta sprites+$400-6,x
		sta sprites+$400-5,x
		sta sprites+$400-4,x
		sta sprites+$400-3,x
		sta sprites+$400-2,x
		sta sprites+$400-1,x
		
		sta sprites+$500-8,x		
		sta sprites+$500-7,x
		sta sprites+$500-6,x
		sta sprites+$500-5,x
		sta sprites+$500-4,x
		sta sprites+$500-3,x
		sta sprites+$500-2,x
		sta sprites+$500-1,x
		
		rts
		
dy1
		sta sprites+$400+$13,x
		sta sprites+$500+$13,x
		sta sprites+$400+$14,x
		sta sprites+$500+$14,x
		sta sprites+$400+$15,x
		sta sprites+$500+$15,x
		sta sprites+$400+$16,x
		sta sprites+$500+$16,x
		sta sprites+$400+$17,x
		sta sprites+$500+$17,x
		sta sprites+$400+$18,x
		sta sprites+$500+$18,x
		jmp dy7+36
		
		
dy2	
		sta sprites+$400+$13,x
		sta sprites+$500+$13,x
		sta sprites+$400+$14,x
		sta sprites+$500+$14,x
		sta sprites+$400+$15,x
		sta sprites+$500+$15,x
		sta sprites+$400+$16,x
		sta sprites+$500+$16,x
		sta sprites+$400+$17,x
		sta sprites+$500+$17,x
		jmp dy7+30
		
dy3	
		sta sprites+$400+$13,x
		sta sprites+$500+$13,x
		sta sprites+$400+$14,x
		sta sprites+$500+$14,x
		sta sprites+$400+$15,x
		sta sprites+$500+$15,x
		sta sprites+$400+$16,x
		sta sprites+$500+$16,x
		jmp dy7+24
		
dy4
		sta sprites+$400+$13,x
		sta sprites+$500+$13,x
		sta sprites+$400+$14,x
		sta sprites+$500+$14,x
		sta sprites+$400+$15,x
		sta sprites+$500+$15,x
		jmp dy7+18		
		
		
dy5	
		cpx #POSY_MAX-32
		bcs dy7+12
		sta sprites+$400+$13,x
		sta sprites+$500+$13,x
		sta sprites+$400+$14,x
		sta sprites+$500+$14,x
		jmp dy7+12		
		
dy6		
		sta sprites+$400+$13,x
		sta sprites+$500+$13,x
		jmp dy7+6
		
dy7
		sta sprites+$400-7,x
		sta sprites+$500-7,x
		sta sprites+$400-6,x
		sta sprites+$500-6,x
		sta sprites+$400-5,x
		sta sprites+$500-5,x
		sta sprites+$400-4,x
		sta sprites+$500-4,x		
		sta sprites+$400-3,x
		sta sprites+$500-3,x
		sta sprites+$400-2,x
		sta sprites+$500-2,x
		sta sprites+$400-1,x		
		sta sprites+$500-1,x
		
		sta sprites+$400+$10,x		
		sta sprites+$400+$11,x
		sta sprites+$400+$12,x
		sta sprites+$500+$10,x		
		sta sprites+$500+$11,x
		sta sprites+$500+$12,x
		rts

		
		.align
		
tab_skok23	dta <dy0b,<dy1b,<dy2b,<dy3b,<dy4b,<dy5b,<dy6b,<dy7b		

		
dy0b	
		sta sprites+$600+$11,x
		sta sprites+$700+$11,x 
	
		sta sprites+$600+$10,x
		sta sprites+$700+$10,x
		
		sta sprites+$600-8,x
		sta sprites+$600-7,x
		sta sprites+$600-6,x
		sta sprites+$600-5,x
		sta sprites+$600-4,x
		sta sprites+$600-3,x
		sta sprites+$600-2,x
		sta sprites+$600-1,x
		
		sta sprites+$700-8,x		
		sta sprites+$700-7,x
		sta sprites+$700-6,x
		sta sprites+$700-5,x
		sta sprites+$700-4,x
		sta sprites+$700-3,x
		sta sprites+$700-2,x
		sta sprites+$700-1,x
		
		rts
		
dy1b
		sta sprites+$600+$13,x
		sta sprites+$700+$13,x
		sta sprites+$600+$14,x
		sta sprites+$700+$14,x
		sta sprites+$600+$15,x
		sta sprites+$700+$15,x
		sta sprites+$600+$16,x
		sta sprites+$700+$16,x
		sta sprites+$600+$17,x
		sta sprites+$700+$17,x
		sta sprites+$600+$18,x
		sta sprites+$700+$18,x
		jmp dy7b+36
		
		
dy2b	
		sta sprites+$600+$13,x
		sta sprites+$700+$13,x
		sta sprites+$600+$14,x
		sta sprites+$700+$14,x
		sta sprites+$600+$15,x
		sta sprites+$700+$15,x
		sta sprites+$600+$16,x
		sta sprites+$700+$16,x
		sta sprites+$600+$17,x
		sta sprites+$700+$17,x
		jmp dy7b+30
		
dy3b	
		sta sprites+$600+$13,x
		sta sprites+$700+$13,x
		sta sprites+$600+$14,x
		sta sprites+$700+$14,x
		sta sprites+$600+$15,x
		sta sprites+$700+$15,x
		sta sprites+$600+$16,x
		sta sprites+$700+$16,x
		jmp dy7b+24
		
dy4b
		sta sprites+$600+$13,x
		sta sprites+$700+$13,x
		sta sprites+$600+$14,x
		sta sprites+$700+$14,x
		sta sprites+$600+$15,x
		sta sprites+$700+$15,x
		jmp dy7b+18
		
dy5b	
		sta sprites+$600+$13,x
		sta sprites+$700+$13,x
		sta sprites+$600+$14,x
		sta sprites+$700+$14,x
		jmp dy7b+12		
		
		
dy6b		
		sta sprites+$600+$13,x
		sta sprites+$700+$13,x
		jmp dy7b+6

dy7b
		sta sprites+$600-7,x
		sta sprites+$700-7,x
		sta sprites+$600-6,x
		sta sprites+$700-6,x
		sta sprites+$600-5,x
		sta sprites+$700-5,x
		sta sprites+$600-4,x
		sta sprites+$700-4,x		
		sta sprites+$600-3,x
		sta sprites+$700-3,x
		sta sprites+$600-2,x
		sta sprites+$700-2,x
		sta sprites+$600-1,x		
		sta sprites+$700-1,x
		
		sta sprites+$600+$10,x		
		sta sprites+$600+$11,x
		sta sprites+$600+$12,x
		sta sprites+$700+$10,x		
		sta sprites+$700+$11,x
		sta sprites+$700+$12,x
		rts	
		
.endl
		